// Code generated by "enumer -type=SpanType -json -text -yaml -sql"; DO NOT EDIT.

package spanTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _SpanTypeName = "WrapperAnchorImageLidMediaNidNoteSidRid"

var _SpanTypeIndex = [...]uint8{0, 7, 13, 18, 21, 26, 29, 33, 36, 39}

func (i SpanType) String() string {
	if i < 0 || i >= SpanType(len(_SpanTypeIndex)-1) {
		return fmt.Sprintf("SpanType(%d)", i)
	}
	return _SpanTypeName[_SpanTypeIndex[i]:_SpanTypeIndex[i+1]]
}

var _SpanTypeValues = []SpanType{0, 1, 2, 3, 4, 5, 6, 7, 8}

var _SpanTypeNameToValueMap = map[string]SpanType{
	_SpanTypeName[0:7]:   0,
	_SpanTypeName[7:13]:  1,
	_SpanTypeName[13:18]: 2,
	_SpanTypeName[18:21]: 3,
	_SpanTypeName[21:26]: 4,
	_SpanTypeName[26:29]: 5,
	_SpanTypeName[29:33]: 6,
	_SpanTypeName[33:36]: 7,
	_SpanTypeName[36:39]: 8,
}

// SpanTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func SpanTypeString(s string) (SpanType, error) {
	if val, ok := _SpanTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to SpanType values", s)
}

// SpanTypeValues returns all values of the enum
func SpanTypeValues() []SpanType {
	return _SpanTypeValues
}

// IsASpanType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i SpanType) IsASpanType() bool {
	for _, v := range _SpanTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for SpanType
func (i SpanType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for SpanType
func (i *SpanType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("SpanType should be a string, got %s", data)
	}

	var err error
	*i, err = SpanTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for SpanType
func (i SpanType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for SpanType
func (i *SpanType) UnmarshalText(text []byte) error {
	var err error
	*i, err = SpanTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for SpanType
func (i SpanType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for SpanType
func (i *SpanType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = SpanTypeString(s)
	return err
}

func (i SpanType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *SpanType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := SpanTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
